// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.hibernate.metafacades;

import org.andromda.metafacades.uml.EntityAssociationEnd;

/**
 * <p>
 * Represents an association end between Hibernate entities.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface HibernateAssociationEnd
    extends EntityAssociationEnd
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isHibernateAssociationEndMetaType();

    /**
     * 
     * @return String
     */
    public String getCollectionIndexName();

    /**
     * <p>
     * this will only apply for Maps, it will return the type of the
     * attribute specified on the CollectionIndexName tagged value
     * </p>
     * @return String
     */
    public String getCollectionIndexType();

    /**
     * 
     * @return String
     */
    public String getCollectionType();

    /**
     * <p>
     * The actual implementation of the collection type.
     * </p>
     * @return String
     */
    public String getCollectionTypeImplementation();

    /**
     * 
     * @return String
     */
    public String getEmbedXML();

    /**
     * <p>
     * Stores the value indicating how a UML aggregation should be
     * interpreted as cascade.
     * </p>
     * @return String
     */
    public String getHibernateAggregationCascade();

    /**
     * <p>
     * Stores the hibernate cascade attribute of this association end.
     * </p>
     * @return String
     */
    public String getHibernateCascade();

    /**
     * <p>
     * Stores the value indicating how a UML composition should be
     * interpreted as cascade.
     * </p>
     * @return String
     */
    public String getHibernateCompositionCascade();

    /**
     * 
     * @return String
     */
    public String getOrderByColumns();

    /**
     * <p>
     * This value will determine how Hibernate manages the asocciation
     * on a many to one and one to one relation. It will tell hibernate
     * how  to use outerJoins. Values: auto,false,true
     * </p>
     * @return String
     */
    public String getOuterJoin();

    /**
     * 
     * @return String
     */
    public String getSortType();

    /**
     * 
     * @return String
     */
    public String getWhereClause();

    /**
     * 
     * @return String
     */
    public String getXmlTagName();

    /**
     * 
     * @return boolean
     */
    public boolean isBag();

    /**
     * 
     * @return boolean
     */
    public boolean isBidirectionalOrderedListChild();

    /**
     * 
     * @return boolean
     */
    public boolean isBidirectionalOrderedListParent();

    /**
     * <p>
     * Whether or not the hibernate inverse attribute is true or false.
     * </p>
     * @return boolean
     */
    public boolean isHibernateInverse();

    /**
     * 
     * @return boolean
     */
    public boolean isIndexedCollection();

    /**
     * 
     * @return boolean
     */
    public boolean isLazy();

    /**
     * 
     * @return boolean
     */
    public boolean isList();

    /**
     * 
     * @return boolean
     */
    public boolean isMap();

    /**
     * <p>
     * Returns whether or not a one-to-one mapping should be the
     * "primary" mapping for the one2one. It returns a true if this
     * one2one end is an aggregation or a composite. If using the
     * foriegn key association approach, this end will get the foreign
     * key column definition. If using the primary key association
     * approach, this end will get the independent primary key and the
     * other end will get the dependent primary key (i.e. its primary
     * key will be a foreign key to this table).
     * </p>
     * @return boolean
     */
    public boolean isOne2OnePrimary();

    /**
     * <p>
     * Determines if this association end if the owning side.  Used in
     * one-to-one and many-to-many relationships.
     * </p>
     * @return boolean
     */
    public boolean isOwning();

    /**
     * 
     * @return boolean
     */
    public boolean isSet();
}