// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.hibernate.metafacades;

import java.util.Collection;
import org.andromda.metafacades.uml.Entity;

/**
 * <p>
 * Represents an hibernate persistent entity.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface HibernateEntity
    extends Entity
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isHibernateEntityMetaType();

    /**
     * <p>
     * Return all the user defined operations for this entity. Used
     * when leafImpl is true.
     * </p>
     * @return Collection
     */
    public Collection getAllBusinessOperations();

    /**
     * <p>
     * EhCache property. Defines the maximum number of objects that
     * will be created in memory.
     * </p>
     * @return int
     */
    public int getEhCacheMaxElementsInMemory();

    /**
     * <p>
     * EhCache property. Defines the time to idle for an element before
     * it expires.
     * </p>
     * @return int
     */
    public int getEhCacheTimeToIdleSeconds();

    /**
     * <p>
     * EhCache property. Defines the time to live for an element before
     * it expires.
     * </p>
     * @return int
     */
    public int getEhCacheTimeToLiveSeconds();

    /**
     * <p>
     * The name of the implementation class.
     * </p>
     * @return String
     */
    public String getEntityImplementationName();

    /**
     * <p>
     * The name used for the hibernate entity.
     * </p>
     * @return String
     */
    public String getEntityName();

    /**
     * 
     * @return String
     */
    public String getFullyQualifiedEntityImplementationName();

    /**
     * 
     * @return String
     */
    public String getFullyQualifiedEntityName();

    /**
     * <p>
     * Cache policy for the entity. Posible values are read-write,
     * nonstrict-read-write, read-only
     * </p>
     * @return String
     */
    public String getHibernateCacheType();

    /**
     * 
     * @return String
     */
    public String getHibernateDefaultCascade();

    /**
     * <p>
     * The name of the discriminator column. Default is class.
     * </p>
     * @return String
     */
    public String getHibernateDiscriminatorColumn();

    /**
     * <p>
     * The standard length of a discriminator value. Default is 1.
     * </p>
     * @return int
     */
    public int getHibernateDiscriminatorLength();

    /**
     * <p>
     * The type of the hibernate discriminator column. Default is
     * string.
     * </p>
     * @return String
     */
    public String getHibernateDiscriminatorType();

    /**
     * <p>
     * The name of the discriminator value. Default is the name of the
     * class
     * </p>
     * @return String
     */
    public String getHibernateDiscriminatorValue();

    /**
     * 
     * @return String
     */
    public String getHibernateGeneratorClass();

    /**
     * <p>
     * Return the value of andromda.hibernate.inheritance tagged value.
     * </p>
     * @return String
     */
    public String getHibernateInheritanceStrategy();

    /**
     * <p>
     * Stores the value of the Hibernate version property.
     * </p>
     * @return String
     */
    public String getHibernateVersionProperty();

    /**
     * <p>
     * The SQL name of the hibernate version property.
     * </p>
     * @return String
     */
    public String getHibernateVersionPropertySqlName();

    /**
     * <p>
     * Returns the mapping class name to use (this is will be 'class',
     * 'subclass', etc) depending on whether the entity is a
     * specialization and what type of inheritance strategy is
     * employed.
     * </p>
     * @return String
     */
    public String getMappingClassName();

    /**
     * <p>
     * Gets the sequence name.
     * </p>
     * @return String
     */
    public String getSequenceName();

    /**
     * <p>
     * Gets the name of the key column if the inheritance strategy is
     * "subclass".  If the strategy is not "subclass" this returns
     * null.
     * </p>
     * @return String
     */
    public String getSubclassKeyColumn();

    /**
     * 
     * @return int
     */
    public int getVersion();

    /**
     * 
     * @return String
     */
    public String getXmlTagName();

    /**
     * <p>
     * Indicates whether or not any entity operations are present.
     * </p>
     * @return boolean
     */
    public boolean isBusinessOperationsPresent();

    /**
     * <p>
     * Specifies if hibernate dynamic-insert will be enabled / disabled
     * for this entity
     * </p>
     * @return boolean
     */
    public boolean isDynamicInsert();

    /**
     * <p>
     * Specifies if hibernate dynamic-update will be enabled / disabled
     * for this entity
     * </p>
     * @return boolean
     */
    public boolean isDynamicUpdate();

    /**
     * <p>
     * EhCache property. Defines if elements are eternal.
     * </p>
     * @return boolean
     */
    public boolean isEhCacheEternal();

    /**
     * <p>
     * EhCache property. Defines if elements can overflow to disk
     * </p>
     * @return boolean
     */
    public boolean isEhCacheOverflowToDisk();

    /**
     * <p>
     * Indicates whether or not hibernate generator class for this
     * SpringEntity is foreign or not.
     * </p>
     * @return boolean
     */
    public boolean isForeignHibernateGeneratorClass();

    /**
     * <p>
     * Specifies whether the cache for this entity is to be
     * distributed.
     * </p>
     * @return boolean
     */
    public boolean isHibernateCacheDistributed();

    /**
     * <p>
     * Return true if the hibernate inheritance strategy as specified
     * by the tagged value andromda_inheritance_strategy is defined as
     * class.
     * </p>
     * @return boolean
     */
    public boolean isHibernateInheritanceClass();

    /**
     * <p>
     * Return true if the hibernate inheritance strategy as specified
     * by the tagged value andromda_inheritance_strategy is defined as
     * concrete.
     * </p>
     * @return boolean
     */
    public boolean isHibernateInheritanceConcrete();

    /**
     * <p>
     * Return true if the hibernate inheritance strategy as specified
     * by the tagged value andromda_inheritance_strategy is defined as
     * interface.
     * </p>
     * @return boolean
     */
    public boolean isHibernateInheritanceInterface();

    /**
     * <p>
     * Return true if the hibernate inheritance strategy as specified
     * by the tagged value andromda_inheritance_strategy is defined as
     * subclass.
     * </p>
     * @return boolean
     */
    public boolean isHibernateInheritanceSubclass();

    /**
     * 
     * @return boolean
     */
    public boolean isHibernateInheritanceUnionSubClass();

    /**
     * 
     * @return boolean
     */
    public boolean isHibernateProxy();

    /**
     * <p>
     * Specifies whether the entity should be loaded lazily.
     * </p>
     * @return boolean
     */
    public boolean isLazy();

    /**
     * <p>
     * Indicates whether or not the mapping for the the entity requires
     * the properties of the super entity to be included within the
     * mapping.  If this evalutes to true, then the properties of this
     * entity would be rendered into the specialization's mapping file.
     * </p>
     * @return boolean
     */
    public boolean isMappingRequiresSuperProperties();

    /**
     * <p>
     * Indicates if this entity requires a mapping of its own.
     * </p>
     * @return boolean
     */
    public boolean isRequiresMapping();

    /**
     * <p>
     * Indicates if the entity requires specialization mappng.  This
     * happens when the inheritance strategy is "subclass", or "class".
     * </p>
     * @return boolean
     */
    public boolean isRequiresSpecializationMapping();

    /**
     * <p>
     * Indicates whether or not the hibernate generator class is
     * specified as "sequence".
     * </p>
     * @return boolean
     */
    public boolean isSequenceHibernateGeneratorClass();

    /**
     * <p>
     * Indicates if a table is required for this entity (sometimes it
     * will not be depending on the inheritance strategy used).
     * </p>
     * @return boolean
     */
    public boolean isTableRequired();
}